version: '2'
services:
  zookeeper:
    image: confluentinc/cp-zookeeper:6.2.0
    hostname: zookeeper
    container_name: zookeeper
    ports:
      - "2181:2181"
    environment:
      ZOOKEEPER_CLIENT_PORT: 2181
      ZOOKEEPER_TICK_TIME: 2000

  kafka:
    image: confluentinc/cp-kafka:6.2.0
    hostname: broker
    container_name: broker
    depends_on:
      - zookeeper
    ports:
      - "29092:29092"
      - "9092:9092"
      - "9101:9101"
    environment:
      KAFKA_BROKER_ID: 1
      KAFKA_ZOOKEEPER_CONNECT: 'zookeeper:2181'
      KAFKA_LISTENER_SECURITY_PROTOCOL_MAP: PLAINTEXT:PLAINTEXT,PLAINTEXT_HOST:PLAINTEXT
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://kafka:29092,PLAINTEXT_HOST://localhost:9092
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
      KAFKA_TRANSACTION_STATE_LOG_MIN_ISR: 1
      KAFKA_TRANSACTION_STATE_LOG_REPLICATION_FACTOR: 1
      KAFKA_GROUP_INITIAL_REBALANCE_DELAY_MS: 0
      KAFKA_JMX_PORT: 9101
      KAFKA_JMX_HOSTNAME: localhost

  kiwi:
    hostname: kiwi
    container_name: kiwi
    image: dmwood/kiwi:0.9.3
    environment:
      KAFKA_BASE_CLIENT_BOOTSTRAPSERVERS: kafka:29092
    ports:
      - 8090:8080

  init-kafka:
    image: confluentinc/cp-kafka:6.2.0
    depends_on:
      - kafka
    entrypoint: [ '/bin/sh', '-c' ]
    command: |
      "
      # blocks until kafka is reachable
      kafka-topics --bootstrap-server kafka:29092 --list

      echo -e 'Creating kafka topics'
      kafka-topics --bootstrap-server kafka:29092 --create --if-not-exists --topic read-model --config "cleanup.policy=compact"
      kafka-topics --bootstrap-server kafka:29092 --create --if-not-exists --topic requests
      kafka-topics --bootstrap-server kafka:29092 --create --if-not-exists --topic responses
      kafka-topics --bootstrap-server kafka:29092 --create --if-not-exists --topic accepted-events
      kafka-topics --bootstrap-server kafka:29092 --create --if-not-exists --topic events-store
      kafka-topics --bootstrap-server kafka:29092 --create --if-not-exists --topic notifications

      echo -e 'Successfully created the following topics:'
      kafka-topics --bootstrap-server kafka:29092 --list
      "
  theapp:
    image: themarlowtask:1.0.0
    depends_on:
      - init-kafka
    command: [ /opt/docker/bin/main-app, kafka:29092 ]
  notifier:
    image: themarlowtask:1.0.0
    depends_on:
      - init-kafka
    command: [ /opt/docker/bin/notifier, kafka:29092 ]

